/******************************************************************************
  * @file    PT32x033x_LDAC.h
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2020/9/1
  * @brief    This file contains all the functions prototypes for the CMP/OPA firmware library
  *
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef PT32x033x_LDAC_H
#define PT32x033x_LDAC_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "PT32x033x.h"


/** @addtogroup Analog comparators and operational amplifiers
  * @{
  */

/* Exported types ------------------------------------------------------------*/

#define IS_LDAC_ALL_PERIPH(PERIPH)       (((PERIPH) == LDAC0) || ((PERIPH) == LDAC1))
#define IS_LDAC_VALUE(VALUE)       ((VALUE) <= 0x1F)

void LDAC_SETData(LDAC_TypeDef* LDACx, u32 LDAC_DACValue);
	
/**
  * @}
  */
  
#ifdef __cplusplus
}
#endif

#endif

