/******************************************************************************
  * @file    PT32x033x_ldac.c
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   This file provides firmware functions to manage the following
  *          functionalities of the CMP/OPA peripheral:
  *           + Initialization and Configuration
  *           + Interrupts and flags management
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/


/* Includes ------------------------------------------------------------------*/
#include "PT32x033x_ldac.h"
/**
  * @brief  Set the LDAC Value.
  * @param  LDACx: where x can be 0 or 1 to select the LDACx peripheral.
  * @param  LDAC_DACValue: LDAC_DACValue can be 0 or 0x1f.
  * @retval None.
  */
void LDAC_SETData(LDAC_TypeDef* LDACx, u32 LDAC_DACValue)
{
	/* Check the parameters */
	assert_param(IS_LDAC_ALL_PERIPH(LDACx));
	assert_param(IS_LDAC_VALUE(LDAC_DACValue));
	
	/*  */
	LDACx->DR = LDAC_DACValue;
}


/**
  * @}
  */
