/**
  ******************************************************************************
  * @file    system_PT32x033x.c
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   
  ******************************************************************************
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  */


/* Includes ------------------------------------------------------------------*/
#include "PT32x033x.h"


/** @addtogroup PT32x033x_StdPeriph_Driver
  * @{
  */


/** @addtogroup CLK
  * @{
  */


/** @defgroup CLK_Private_Defines
  * @{
  */

/**
  * @}
  */
void Wait_ClockReady(void)
{
	u8 i,j;
	for(i=0; i<100; i++)
		for(j=0; j<48; j++);
}



//<<< Use Configuration Wizard in Context Menu >>>
/*--------------------- Clock Configuration ----------------------------------
//
//    <h> HSI(8M)
//      <q0>    ʹ
//                <i> Ĭ = ENABLE
//    </h>
//
//    <h> HSE(4~25M)
//      <e1>    ʹ
//                <i> Ĭ = DISABLE
//        <o2>  ⲿʱԴ
//                <0=> ⲿپ 
//                <1=> ʱ 
//      </e>
//    </h>
//    <h> LSE(32.768KHz)
//      <e3>    ʹ
//                <i> Ĭ = DISABLE
//        <o4>  ⲿʱԴ
//                <0=> ⲿپ 
//                <1=> ʱ 
//      </e>
//    </h>
//    <h> PLL
//      <e5>    PLLʹ
//                <i> Ĭ  = DISABLE
//        <o6>  PLLʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> LSI
//                <i> ĬPLLʱԴ = Internal RC
//                <i> PLLʱԴƵ = Source clock * 2
//      </e>
//    </h>
//    <h> ϵͳʱ(HS_CLK)
//      <o7>    ϵͳʱԴ
//                <0=> HSI
//                <1=> HSE
//                <2=> PLL
//                <3=> LSI
//                <i> ĬϵͳʱԴ = Internal RC_8M
//      <o8>  HCLKƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//                <5=> 32
//                <i> ĬϷƵ = 1
//      <o9>    PCLKƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//                <5=> 32
//                <i> ĬϷƵ= 1
//    </h>
//
//    <h> IFMC 
//      <o10>   Flash ȴ
//                <0=> 0 WS
//                <1=> 1 WS
//                <i> 0 WS:  1 KHz <= HCLK <= 24 MHz
//                <i> 1 WS: 24 MHz <  HCLK <= 48 MHz
//    </h>
//
//    <h>  MCO
//      <e11>    MCOʹ
//                <i> Ĭ = DISABLE 
//        <o12>    MCO
//                <0=> PA0
//                <1=> PD1
//								<2=> PB4
//        <o13>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//    </e>
//    </h>
//
//    <o14>ǰHSEƵ
//    <i>Default: 25000000 (Unit:Hz)
//    <0-25000000>
*/


/** @defgroup CLK_Private_Defines
  * @{
  */

#define IOSC_8M_ENABLE	(1)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define EOSC_CLK_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                              */
#define EOSC_CLK_SRC  (0)       /*!< 0: CRYSTAL,  1: EOSC_CLK 																						*/
#define EOSC_32K_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define EOSC_LSE_SRC  (0)       /*!< 0: CRYSTAL,  1: EOSC_CLK 																						*/
#define PLL_CLK_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define PLL_CLK_SRC	(1)     /*!< 0: IOCS_24M, 1: EOSC_CLK    2:IOSC_32K                               */
#define HCLK_SRC	(0)     /*!< 0: IOCS_24M, 1: EOSC_CLK    2:FD_CLK     3:IOSC_32K                  */
#define HCLK_DIV	(0)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */
#define PCLK_DIV	(0)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */
#define WAIT_STATE	(0)     /*!< 0: 0 WS,     1: 1 WS,   2: 2 WS,                                     */
#define MCO_ENABLE	(0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define MCO_PINSEL	(1)     /*!< 0: PA8,      1: PB2,                                                */
#define MCO_DIV		(3)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */
#define MCU_SYSTICK_FREQUENCE (25000000)


#define  IOSC_RC8M_VALUE     8000000UL
#define  I0SC_32K_VALUE       32768UL

/**
  * @}
  */


/** @defgroup CLK_Private_Functions
  * @{
  */


/**
* @brief ʱԴ
* @param IOSC_8M_ENABLE		ָ,ƬRC8Mʱʹܿ
* @param EOSC_CLK_ENABLE	ָ,ⲿƵʱʹܿ
* @param EOSC_32K_ENABLE	ָ,ⲿƵʱʹܿ
* @retval None
*/
void clk_source_config(void)
{
	#if (IOSC_8M_ENABLE == 1)
		RCC_OscillatorCmd(Oscillator_HSI,ENABLE);		//ʹڲRC 8M
	#else
		RCC_OscillatorCmd(Oscillator_HSI,DISABLE);	//رڲRC 8M
	#endif
	
	#if (EOSC_CLK_ENABLE == 1)
	  #if (EOSC_CLK_SRC==0)
			GPIO_DigRemapConfig(AFIOB,AFIO_Pin_8,AFIO_AF_0,ENABLE);
			GPIO_DigRemapConfig(AFIOB,AFIO_Pin_9,AFIO_AF_0,ENABLE);
			RCC->HSECR1&=~RCC_HSECR1_ECEN;
			RCC_OscillatorCmd(Oscillator_HSE,ENABLE);		
			while(RCC_OscillatorReady(HCK_FLAG_RDY) != SET);
		#endif
		#if (EOSC_CLK_SRC==1)
			RCC->HSECR1&=~RCC_HSECR1_EN;
			RCC->HSECR1|=RCC_HSECR1_ECEN;
		#endif
	#else
		RCC_OscillatorCmd(Oscillator_HSE,DISABLE);	
	#endif

	#if (EOSC_32K_ENABLE == 1)
		#if (EOSC_LSE_SRC==0)
			GPIO_DigRemapConfig(AFIOB,AFIO_Pin_10,AFIO_AF_0,ENABLE);
			GPIO_DigRemapConfig(AFIOB,AFIO_Pin_11,AFIO_AF_0,ENABLE);
			RCC->LSECR2=0x291F;
			RCC_OscillatorCmd(Oscillator_LSE,ENABLE);
			while(RCC_OscillatorReady(LCK_FLAG_RDY) != SET);
			#endif
		#if (EOSC_LSE_SRC==1)
			RCC->LSECR1&=~0x1;
			RCC->LSECR1|=0x2;
			RCC_OscillatorCmd(Oscillator_LSE,ENABLE);
		#endif		
	#else
		RCC_OscillatorCmd(Oscillator_LSE,DISABLE);
	#endif
}


/**
* @brief ʱԴ໷
* @param PLL_CLK_ENABLE		ָ,໷ʹ
* @param PLL_CLK_SRC			ָ,
*     @arg 0: ƵʱԴѡڲRC
*     @arg 1: ƵʱԴѡⲿʱ
*     @arg 2: ƵʱԴѡڲRC 32K						
* @retval None
*/
void  clk_pll_config(void)
{
	#if (PLL_CLK_ENABLE == 1)
		RCC_PLL_Cmd(DISABLE);

		#if (PLL_CLK_SRC == 0 )
			#if (IOSC_8M_ENABLE == 0)
				#error "PLL_CLK ʱԴIOSC_8M δʹ "
			#else
				RCC->CFGR&= ~RCC_CFGR_PLLSRC;
			#endif
		#endif
	
		#if (PLL_CLK_SRC == 1 )
			#if (EOSC_CLK_ENABLE == 0)
				#error "PLL_CLK ʱԴEOSC_CLK δʹ"
			#else
				RCC->CFGR|=RCC_PLLClockSource_HSE;
			#endif
		#endif
	
		#if (PLL_CLK_SRC == 2 )
			RCC->CFGR&=~0xc;
			RCC->CFGR|=RCC_PLLClockSource_LSI;
		#endif
		
		RCC_PLL_Cmd(ENABLE);
	#else
		RCC_PLL_Cmd(DISABLE);
	#endif
}


/**
* @brief ϵͳʱ
* @param HCLK_SRC		ָ,
*     @arg 0: ʱԴѡڲRC32K
*     @arg 1: ʱԴѡⲿʱ
*     @arg 2: ʱԴѡڲPLLƵʱ
*     @arg 3: ʱԴѡڲƵʱ
* @param HCLK_DIV		ָ,HCLKķƵϵ
* @param PCLK_DIV		ָ,PCLKķƵϵ
* @retval None
*/
void clk_hsclk_set(void)
{
	#if (HCLK_SRC == 0 )
		#if (IOSC_8M_ENABLE == 0)
			#error "ϵͳʱԴIOSC_8M δʹ"
		#else
			RCC->CFGR&=~RCC_SystemClock_LSI;
		#endif
	#endif

	#if (HCLK_SRC == 1 )
		#if (EOSC_CLK_ENABLE == 0)
			#error "ϵͳʱԴEOSC_CLK δʹ"
		#else
			Wait_ClockReady();		
			RCC->CFGR|=RCC_SystemClock_HSE;
	
			//ʱӰȫƴ
			if (IOSC_8M_ENABLE == 0)	RCC_OscillatorCmd(Oscillator_HSI,DISABLE);	//رڲRC 8M
		#endif
	#endif

	#if (HCLK_SRC == 2 )
		#if (PLL_CLK_ENABLE == 0)
			#error "ϵͳʱԴPLL_CLK δʹ"
		#else
			RCC->CFGR|=RCC_SystemClock_PLL;
			if(PLL_CLK_SRC!=2)	Wait_ClockReady();
			
			//ʱӰȫƴ
			if (IOSC_8M_ENABLE == 0)	RCC_OscillatorCmd(Oscillator_HSI,DISABLE);	//رڲRC 8M
		#endif
	#endif
	
	#if (HCLK_SRC == 3 )
		RCC_OscillatorCmd(Oscillator_LSI,ENABLE);	//ڲƵʱʹ
		RCC->CFGR&=~(RCC_CFGR_SCW|RCC_CFGR_PLLSRC);
		RCC->CFGR|=RCC_SystemClock_LSI;

		//ʱӰȫƴ
		if (IOSC_8M_ENABLE == 0)	RCC_OscillatorCmd(Oscillator_HSI,DISABLE);	//رڲRC 8M
	#endif

	RCC->CFGR |=(HCLK_DIV<<4);		//HCLKƵѡ
	RCC->CFGR |=(PCLK_DIV<<8);		//PCLKƵѡ
	
	if((RCC->CFGR&0X03) != HCLK_SRC)	//ϵͳʱѡ
	{
		while(1);
	}
	RCC->CFGR |= RCC_CFGR_WKCK;
}

/**
* @brief ϵͳʱ
* @param MCO_ENABLE	ָ,ϵͳʱʹ
* @param MCO_PINSEL		ָ,
*     @arg 0: ϵͳʱPA8
*     @arg 1: ϵͳʱPD1
* @param MCO_DIV		ϵͳʱķƵ
* @retval None
*/
void clk_mco_config(void)
{
	#if (MCO_ENABLE == 1)
		#if (MCO_PINSEL == 0)
   	GPIO_DigRemapConfig(AFIOA,AFIO_Pin_0,AFIO_AF_1,ENABLE);
		#endif
		#if (MCO_PINSEL == 1)
	  GPIO_DigRemapConfig(AFIOD,AFIO_Pin_1,AFIO_AF_1,ENABLE);		
		#endif
		#if (MCO_PINSEL == 2)
	  GPIO_DigRemapConfig(AFIOB,AFIO_Pin_4,AFIO_AF_2,ENABLE);		
		#endif
	RCC->MCOR=MCO_DIV;
	#endif
}


/**
* @brief ȡϵͳʱ
* @param none
* @retval None
*/
u32 clk_get_sysclk(void)
{
	u32 SystemCoreClock;
	switch(HCLK_SRC)
	{
		case 0:
			SystemCoreClock=IOSC_RC8M_VALUE;
			break;
			
		case 1:
			SystemCoreClock=MCU_SYSTICK_FREQUENCE;
			break;
			
		case 2:
			if(PLL_CLK_SRC==0)
			{
				SystemCoreClock=IOSC_RC8M_VALUE*2;
			}
			else if(PLL_CLK_SRC==1)
			{
				SystemCoreClock=MCU_SYSTICK_FREQUENCE*2;
			}
			else if(PLL_CLK_SRC==2)
			{
				SystemCoreClock=I0SC_32K_VALUE*2;
			}
			else
			{
				;
			}
			break;
			
		case 3:
			SystemCoreClock=I0SC_32K_VALUE;
			break;
			
		default:
			break;
	}
	return SystemCoreClock;
}


/**
* @brief ϵͳʱӳʼ
* @param none
* @retval None
*/
void SystemInit (void)
{
	clk_source_config();
	
	clk_pll_config();
	
	/* Flash ȴ*/
	IFMC ->CR= ((IFMC_MainCodeKey) | (WAIT_STATE << 5)) ;
	
	clk_hsclk_set();

	clk_mco_config();
}

//<<< end of configuration section >>>

/**
  * @}
  */


/**
  * @}
  */


/**
  * @}
  */


/******************* (C) Ȩ Pai-IC Microelectronics *****END OF FILE****/

