  /******************************************************************************
  * @Example PT32x033_Timer_LED
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ͨTIM2жϣLEDÿ0.1˸һΣ
  *          
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  ******************************************************************************
  * @attention	
  *				
  *						
  *****************************************************************************/

#include "PT32x033x.h"

#define		LED_PORT	GPIOC
#define		LED_PIN	  GPIO_Pin_6

#define		LED_OFF()	GPIO_SetBits(LED_PORT, LED_PIN)
#define		LED_ON()	GPIO_ResetBits(LED_PORT, LED_PIN)

/**
* @brief LEDGPIO
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	//ƫ
	GPIO_InitStructure.GPIO_Pin = LED_PIN;			//ѡҪƵGPIO
	GPIO_Init(LED_PORT, &GPIO_InitStructure);		//ʼGPIO
	
	GPIO_SetBits(LED_PORT, LED_PIN);			//GPIO״̬
}


void TIM_Delay_100ms(void)
{
	
	TIM_TimeBaseInitTypeDef  TimeBaseInit;
	NVIC_ClearPendingIRQ(TIM2_IRQn);
	NVIC_EnableIRQ(TIM2_IRQn);
	
	TimeBaseInit.MatchValue = 9999;	//  0.1MHZ*10000=10HZ
	TimeBaseInit.Prescaler = 79;		// 8/80=0.1MHZ
	TimeBaseInit.CounterMode = TIM_CounterMode_UP;	//ϼ
	TimeBaseInit.OVRSTEN = ENABLE;	//򲻱
	TIM_TimeBaseInit(TIM2, &TimeBaseInit);
	TIM_ITConfig(TIM2,TIMx_IE_UIE,ENABLE);
	TIM_Cmd(TIM2, ENABLE);		//ʹܶʱ
	TIM_ClearFlag(TIM2,TIM_FLAG_MR0);
}

u8 TIM_IT_FLAG=0;
int main (void)
{
	LED_Driver();
	TIM_Delay_100ms();
	while(1)
	{		
		if(TIM_IT_FLAG)		//ȡ־Ƿ
		{
			LED_ON();
		}
		else
		{
			LED_OFF();
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %lu\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


