/******************************************************************************
  * @Example  PWM
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ʹø߼ʱTIM0PWMPWMͨPB4
						 ʹͨʱTIM2ΪTIM0ṩ100HzĶʱ
						 ÿ10msTIM2жϺ󣬸ıTIM0PWMռձ
						 PB4LEDƼʵֺЧ
  *          
  ******************************************************************************
  * @attention	
  *
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
#include "PT32x033x.h"

/*******************************************************************************
*Function:	TIMER_GPIO_Config
*Description:	TIMER
*Input:		
*Return:		
*Others:
			úʹTIMERģ
*******************************************************************************/
void Advanced_TIMER_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_4, AFIO_AF_1,ENABLE);	//PB4 TIM0_CH1	
}

/*******************************************************************************
*Function:	TIMER_Mode_Config
*Description:	TIMER
*Input:		
*Return:		
*Others:
			úʼTIMERģĹ乤ʽ
*******************************************************************************/
void Advanced_TIMER_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_OutputInitTypeDef		OutPutInit;
		
	TimeBaseInit.PWM_Period = 999;	//  1MHZ*1000=1000HZ
	TimeBaseInit.PWM_Prescaler = 7;		// 8/8=1MHZ
	TimeBaseInit.PWM_ClockSel=PCLK;
	TimeBaseInit.PWM_CounterMode = PWM_CNT_MODE_UP;	//ϼ
	TimeBaseInit.PWM_CounterDirRvEN = PWM_CounterDirRv_DIS;	//򲻱
	PMW_TimeBaseInit(TIM0, &TimeBaseInit);
	
	OutPutInit.Channel=PWM_CH_1;
	OutPutInit.OutputMode=COMPAER_MODE1;		//ֵռձƥĴֵߵƽ
	OutPutInit.ControlN=PWM_OCMR_OC1NE;	//ʹ
	OutPutInit.IdleState=PWM_IDLE_LOW;	//PWMʱ0
	OutPutInit.DeathTime=0;			//ʱ0
	OutPutInit.CompareValue=199;		//ռձ=MR0/MRx
	PWM_OutputInit(TIM0,&OutPutInit);	
	
	PWM_Cmd(TIM0, ENABLE);		//ʹܶʱ
}

void Advanced_Timer_Init(void)
{
	Advanced_TIMER_GPIO_Config();
	Advanced_TIMER_Mode_Config();
}

void TIM_Delay_10ms(void)
{
	TIM_TimeBaseInitTypeDef  TimeBaseInit;
	NVIC_ClearPendingIRQ(TIM2_IRQn);
	NVIC_EnableIRQ(TIM2_IRQn);
	
	TimeBaseInit.MatchValue = 999;	//  0.1MHZ/1000=100HZ
	TimeBaseInit.Prescaler = 79;		// 8/80=0.1MHZ
	TimeBaseInit.CounterMode = TIM_CounterMode_UP;	//ϼ
	TimeBaseInit.OVRSTEN = ENABLE;	//򲻱
	TIM_TimeBaseInit(TIM2, &TimeBaseInit);
	TIM_ITConfig(TIM2,TIMx_IE_UIE,ENABLE);
	TIM_Cmd(TIM2, ENABLE);		//ʹܶʱ
	TIM_ClearFlag(TIM2,TIM_FLAG_MR0);
}
int TIM2_FLAG=0;
int main (void)
{
	int i;
	Advanced_Timer_Init();
	TIM_Delay_10ms();
	while(1)
	{
		for(i=0;i<999;i+=10)
		{
			while(!TIM2_FLAG);
			PWM_SetCompare(TIM0,PWM_CH_1,i);
			TIM2_FLAG=0;
		}
		for(i=0;i<999;i+=10)
		{
			while(!TIM2_FLAG);
			PWM_SetCompare(TIM0,PWM_CH_1,999-i);
			TIM2_FLAG=0;
		}
	}
}
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


