/******************************************************************************
  * @Example IWDG
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   1IWDGĿλͨڴӡȴι䣻
  *			     ״ζNMI_HandlerжϣڲιҲжϱ־
	*          ڶζIWDGλٴͨڴӡ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *							
  *
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
#include "PT32x033x.h"


/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/*******************************************************************************
*Function:	IWDG_Driver
*Description:	 IWDG ĳʱʱ䣬Tout = 1/32768 * rlv (S)
*Input:		rlv:ֵȡֵΧΪ0-0XFFFF
*Return:		
*Others:
*******************************************************************************/
void IWDG_Driver(u32 rlv)
{	
	WDG_LockConfig(IWDG, IWDG_LOCK_UnLock);	//WDGĴ
	WDG_SetReload(IWDG, rlv);				//װؼĴֵ
	WDG_ReloadCounter(IWDG);				//ι(ؼ)
  WDG_ResetConfig(IWDG, ENABLE);			//Źλʹ
	WDG_Cmd(IWDG, ENABLE);					//ʹIWDG
	WDG_LockConfig(IWDG, IWDG_LOCK_Lock);	//סWDGĴ
}

/*******************************************************************************
*Function:	IWDG_Feed
*Description:	ι
*Input:		
*Return:		
*Others:
*******************************************************************************/
void IWDG_Feed(void)
{
	WDG_LockConfig(IWDG, IWDG_LOCK_UnLock);	//WDGĴ
	WDG_ReloadCounter(IWDG);				//ι(ؼ)
	WDG_LockConfig(IWDG, IWDG_LOCK_Lock);	//סWDGĴ	
}

int main (void)
{
	UART_Driver();
	IWDG_Driver(32768);	//timeout=1s	
	printf("ȴιȡιϢϵͳλظ\r\n");
	while(1)
	{
		IWDG_Feed();//ι
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


