  /******************************************************************************
  * @Example IFMC
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ͨдƬIFMCַָ,дݼ飬ͬʱִдַݶ
	* 
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλnoУ
  *		
  *
  *
  *****************************************************************************/

#include "PT32x033x.h"

#define WRITE_START_ADDR  ((uint32_t)0x00007200)	
#define WRITE_END_ADDR    ((uint32_t)0x000072FF)	// 1Kbyte


u32 IFMC_Data[5]={	0x3211ABC9,
										0x4210DCB8,
										0x5210ABC7,
										0x6210DCB6,
										0x7210ABC5};
u8 flash_ok=0;

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}


void Flash_Erase(void)
{
	u32 EraseCounter = 0x00;	//ҪĿ
	u32 NbrOfPage = 0x00;	//
	IFMC_Status IFMCStatus = IFMC_Complete; 	//FlashĽ
	
	/* Ҫٿ(1=512Byte) */
	NbrOfPage = ((WRITE_END_ADDR - WRITE_START_ADDR)+(IFMC_PAGE_SIZE-1)) / IFMC_PAGE_SIZE;  //+1
	
	/* б־λ */
	IFMC_ClearFlag(IFMC_SR_WOV | IFMC_SR_POV | IFMC_SR_COV | IFMC_SR_KERR | IFMC_SR_CERR | IFMC_SR_AERR);	//б־λ
	
	/* */
	for(EraseCounter = 0; (EraseCounter < NbrOfPage) && (IFMCStatus == IFMC_Complete); EraseCounter++)
	{
		IFMCStatus = IFMC_ErasePage(WRITE_START_ADDR + (IFMC_PAGE_SIZE * EraseCounter));
	}
}


void Flash_Write_WordCode(void)
{
	IFMC_Status IFMCStatus = IFMC_Complete; 	//FlashĽ
	u32 Address = 0;		//дַ
	u8 Count_Write=0;	//д

	__disable_irq();	/*ȫж*/
	
	Flash_Erase();
	
	Address = WRITE_START_ADDR;
	while((Count_Write < 5) && (IFMCStatus == IFMC_Complete))	//
	{
		IFMCStatus = IFMC_ProgramWord(Address, IFMC_Data[Count_Write]);
		Address = Address + 4;	//Flashд4ByteΪλ
		Count_Write++;
	}
	__enable_irq();    /*ȫж*/
}

void check_flash(void)
{
	u32 Address = 0;		//ȡַ
	u8 Count_Write=0;	//ȡ
	u8 error_count=0;
	/* дǷȷ */
	Address = WRITE_START_ADDR;
	while((Count_Write < 5))
	{
		if(IFMC_ReadWord(Address) != IFMC_Data[Count_Write])	//ǰֵַ0x3210ABCD
		{
			error_count++;
		}
		Address += 4;
		Count_Write++;
	}
	if(error_count==0)
	{
		printf("Flashд\r\n");
		flash_ok=1;
	}
	if(error_count>0)
	{		
		printf("Flashд쳣\r\n");
		flash_ok=0;
	}
}

/**
* @brief FLASH
* @param 
* @retval 
*/
void Flash_Read_WordCode()
{
	u32 Rx_Buffer[5];
	u32 Address = 0;																//ȡַ	
	u8 Count_Write=0;																//ȡ
	Address = WRITE_START_ADDR;

	while((Count_Write < 5) && !IFMC_GetFlagStatus(IFMC_SR_BUSY))							//BUSY״̬
	{
		Rx_Buffer[Count_Write] = IFMC_ReadWord(Address);							//ýӿڶ
		printf("Ϊ%#lx--ַ%#lx\r\n",Rx_Buffer[Count_Write],Address);
		Address = Address + 4;	
		Count_Write++;		
	}
		printf("ڲFLASH\r\n");
}


int main (void)
{
	UART_Driver();

	Flash_Write_WordCode();
	check_flash();

	printf("ʼڲFLASH\r\n");
	Flash_Read_WordCode();
	printf("*********************************************\r\n");
	while(1);
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


