/******************************************************************************
  * @Example LCD
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ͨLCDĹ̶ҳʾģʽLCDڵ0ҳʾ4797
  *          
  ******************************************************************************
  * @attention	
  *			4COM\28SEG,LCDSC3~LCDSC0ΪCOM,LCDSC11~LCDSC4ΪSEG
  *			ʹø̣ҪPIN  PINĽӷ̽ӰصJ16J17ӿ
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

#define Display_Page 0

#define   LcdSeg_a		0x01
#define   LcdSeg_b		0x10
#define   LcdSeg_f		0x02
#define   LcdSeg_g		0x20
#define   LcdSeg_e		0x04
#define   LcdSeg_c		0x40
#define   LcdSeg_p		0x08
#define   LcdSeg_d		0x80
#define		Char_0		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f
#define  	Char_1		LcdSeg_b+LcdSeg_c
#define		Char_2		LcdSeg_a+LcdSeg_b+LcdSeg_d+LcdSeg_e+LcdSeg_g
#define		Char_3		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_g
#define		Char_4		LcdSeg_b+LcdSeg_c+LcdSeg_f+LcdSeg_g
#define		Char_5		LcdSeg_a+LcdSeg_c+LcdSeg_d+LcdSeg_f+LcdSeg_g
#define		Char_6		LcdSeg_a+LcdSeg_g+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f
#define		Char_7		LcdSeg_a+LcdSeg_b+LcdSeg_c
#define		Char_8		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_9		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_f+LcdSeg_g
#define		Char_A		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_B 		LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_C 		LcdSeg_a+LcdSeg_f+LcdSeg_e+LcdSeg_d
#define		Char_D		LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_g
#define		Char_E		LcdSeg_a+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_F		LcdSeg_a+LcdSeg_f+LcdSeg_e+LcdSeg_g
#define		Char_r    LcdSeg_e+LcdSeg_g
#define		Char_H	 	LcdSeg_b+LcdSeg_c+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define 	Char_L    LcdSeg_d+LcdSeg_e+LcdSeg_f
#define 	Char_Row	LcdSeg_g
#define 	Char_U		LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f

u8 Display_Char_Table[21] =
{
	Char_0,
	Char_1,
	Char_2,
	Char_3,
	Char_4,
	Char_5,
	Char_6,
	Char_7,
	Char_8,
	Char_9,
	Char_A,
	Char_B,
	Char_C,
	Char_D,
	Char_E,
	Char_F,
	Char_r,
	Char_H,
	Char_L,
	Char_Row,
	Char_U
};


void LCD_GPIO_Config(void)
{
	GPIO_AnaRemapConfig(AFIOA, GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5,ENABLE);
	GPIO_AnaRemapConfig(AFIOB, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7, ENABLE);
}
	
void LCD_Mode_Config(void)
{
	LCD_InitTypeDef LCD_InitStruct;

	LCD_StructInit(&LCD_InitStruct);
	LCD_InitStruct.LCD_DriveVoltageType=LCD_DriveVoltageType_R;		//Rƫѹ                      
	LCD_InitStruct.LCD_Duty = LCD_Duty_Div6;		// 1/4DUTY,4COM,28SEG
	LCD_InitStruct.LCD_PageDisplayMode=LCD_PageDisplayMode_Fixed;	//̶ҳʾ
	LCD_Init(&LCD_InitStruct);
	LCD->PCR=0xFFF;				//LCDPIN11~LCDPIN0ʹ
	LCD->PDCR=0x0F;				//LCDPIN3~LCDPIN0ΪCOM,LCDPIN4~LCDPIN11ΪSEG
	LCD->PSC=4;						//֡ˢƵ=32k/(4COM*2*(4FSEL*8+1))Լ120Hz
	LCD->PNR=Display_Page;//ǰҳ
	LCD->PDTR=2;					//ÿҳʾʱ(2*64+1)/120Լ1
	LCD->SDPR=14;					//ҳ14+1

	LCD_Grayscale(LCD_Grayscale85);
	LCD_GrayscaleCMD(ENABLE);
	LCD_ClearPage(Display_Page);	//ҳ0ʾ
	
	LCD_SetDramCOM(LCD_PIN_0,LCD_COM_0,ENABLE);
	LCD_SetDramCOM(LCD_PIN_1,LCD_COM_1,ENABLE);
	LCD_SetDramCOM(LCD_PIN_2,LCD_COM_2,ENABLE);
	LCD_SetDramCOM(LCD_PIN_3,LCD_COM_3,ENABLE);
}


/**
  * @brief  תΪɹLCDȡʾĸʽ
  * @note  
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  * @retval Get_Table_Dataתɵ
  */
u8 Get_Dis_Format(u8 Dis_data)
{
	u8 Get_Table_Data;
	Get_Table_Data = Display_Char_Table[Dis_data];
	return Get_Table_Data;
}



/**
  * @brief  ָݷ͵LCDӦPageĴ
  * @note  
  * @param  Dis_BIT: 1~4ʾDEMOLCDʾλ
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  * @param  Page: 0~15LCDʾĴ16ҳ
  * @retval None
  */
void Buff_Dis_Data_To_Page(u8 Dis_BIT,u8 Dis_Data,u8 Page)
{
	u8 addr_offset=0;
	u8 low_offset=0,high_offset=0;
	u16 Bit16_Low_Byte, Bit16_High_Byte;
	u32 And_Data=0;
	
	Bit16_Low_Byte  =  Dis_Data & 0x0F;
	Bit16_High_Byte  =  Dis_Data >> 4;

	if(Dis_BIT==1||Dis_BIT==3)
	{
		low_offset=0;
		high_offset=8;
		And_Data=0XFFFF0000;
	}
	if(Dis_BIT==2||Dis_BIT==4)
	{
		low_offset=16;
		high_offset=24;
		And_Data=0X0000FFFF;
	}
	
	if(Dis_BIT==1||Dis_BIT==2)
	{
		addr_offset=0X04;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)&=And_Data;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)|=(Bit16_High_Byte << high_offset) | (Bit16_Low_Byte<<low_offset);
	}
	if(Dis_BIT==3||Dis_BIT==4)
	{
		addr_offset=0X08;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)&=And_Data;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)|=(Bit16_High_Byte << high_offset) | (Bit16_Low_Byte << low_offset);
	}
}

/**
  * @brief  ָҺϣʾָ
  * @note  
  * @param  Dis_BIT: 1~4ʾDEMOLCDʾλ
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  *        
  * @retval None
  */
void Display_number(u8 Dis_BIT,u8 Dis_Data,u8 Dis_Page)
{
	Dis_Data=Get_Dis_Format(Dis_Data);
	Buff_Dis_Data_To_Page(Dis_BIT,Dis_Data,Dis_Page);
}

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}

int main (void)
{

	LCD_GPIO_Config();
	LCD_Mode_Config();

	Display_number(1,4,Display_Page);
	Display_number(2,7,Display_Page);
	Display_number(3,9,Display_Page);
	Display_number(4,7,Display_Page);
	
	LCD_CMD(ENABLE);			//ʹLCD	
	LCD_UpdataCMD(ENABLE);	//LCDʾ

	while(1)
	{

	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


