/******************************************************************************
  * @Example LCD Sleep Wake
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ϵLCD˯
	* ˯ߵ£LCDʾ1111FFFF
	* ʹõоƬVDD磬Թ۲
	*	û԰USER KEYMCUԹ۲쵽仯ӰLCDʾ
  * ͨLCD_DriveTypeSelectCͻRѹ         
  ******************************************************************************
  * @attention	
  *			14COM\28SEG,LCDSC3~LCDSC0ΪCOM,LCDSC11~LCDSC4ΪSEG
  *			2ʹø̣ҪPIN  PINĽӷ̽ӰصJ16J17ӿ
	*			3ʱI2Cģ·U3R7R8ᵼ˯߹
	*     4ʱϿ¼ǱҪñӣȷ͹ĵ׼ȷ
	*
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

#define Display_Page 0

#define   LcdSeg_a		0x01
#define   LcdSeg_b		0x10
#define   LcdSeg_f		0x02
#define   LcdSeg_g		0x20
#define   LcdSeg_e		0x04
#define   LcdSeg_c		0x40
#define   LcdSeg_p		0x08
#define   LcdSeg_d		0x80
#define		Char_0		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f
#define  	Char_1		LcdSeg_b+LcdSeg_c
#define		Char_2		LcdSeg_a+LcdSeg_b+LcdSeg_d+LcdSeg_e+LcdSeg_g
#define		Char_3		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_g
#define		Char_4		LcdSeg_b+LcdSeg_c+LcdSeg_f+LcdSeg_g
#define		Char_5		LcdSeg_a+LcdSeg_c+LcdSeg_d+LcdSeg_f+LcdSeg_g
#define		Char_6		LcdSeg_a+LcdSeg_g+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f
#define		Char_7		LcdSeg_a+LcdSeg_b+LcdSeg_c
#define		Char_8		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_9		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_f+LcdSeg_g
#define		Char_A		LcdSeg_a+LcdSeg_b+LcdSeg_c+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_B 		LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_C 		LcdSeg_a+LcdSeg_f+LcdSeg_e+LcdSeg_d
#define		Char_D		LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_g
#define		Char_E		LcdSeg_a+LcdSeg_d+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define		Char_F		LcdSeg_a+LcdSeg_f+LcdSeg_e+LcdSeg_g
#define		Char_r    LcdSeg_e+LcdSeg_g
#define		Char_H	 	LcdSeg_b+LcdSeg_c+LcdSeg_e+LcdSeg_f+LcdSeg_g
#define 	Char_L    LcdSeg_d+LcdSeg_e+LcdSeg_f
#define 	Char_Row	LcdSeg_g
#define 	Char_U		LcdSeg_b+LcdSeg_c+LcdSeg_d+LcdSeg_e+LcdSeg_f

#define LCD_DriveTypeSelect LCD_DriveVoltageType_C  //ѹѡ

u8 Display_Char_Table[21] =
{
	Char_0,
	Char_1,
	Char_2,
	Char_3,
	Char_4,
	Char_5,
	Char_6,
	Char_7,
	Char_8,
	Char_9,
	Char_A,
	Char_B,
	Char_C,
	Char_D,
	Char_E,
	Char_F,
	Char_r,
	Char_H,
	Char_L,
	Char_Row,
	Char_U
};


void LCD_GPIO_Config(void)
{
	GPIO_AnaRemapConfig(AFIOA, GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5,ENABLE);
	GPIO_AnaRemapConfig(AFIOB, GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7, ENABLE);
}
	
void LCD_Mode_Config(void)
{
	int i;
	LCD_InitTypeDef LCD_InitStruct;

	LCD_StructInit(&LCD_InitStruct);
	LCD_InitStruct.LCD_DriveVoltageType=LCD_DriveTypeSelect;		//ѡѹ
	LCD_InitStruct.LCD_PageDisplayMode=LCD_PageDisplayMode_Continue;	//ҳģʽ
	LCD_InitStruct.LCD_TotalResistance=LCD_TotalResistance_360k;//ѡԽ͵
	LCD_Init(&LCD_InitStruct);
	LCD->PCR=0xFFF;		//LCDPIN11~LCDPIN0ʹ
	LCD->PDCR=0x0F;	//LCDPIN3~LCDPIN0ΪCOM,LCDPIN4~LCDPIN11ΪSEG
	LCD->PSC=4;		//֡ˢƵ=32k/(4COM*2*(4FSEL*8+1))Լ120Hz
	LCD->PNR=Display_Page;	//ǰҳ
	LCD->PDTR=2;	//ÿҳʾʱ(2*64+1)/120Լ1
	LCD->SDPR=14;		//ҳ14+1
	if(LCD_DriveTypeSelect==LCD_DriveVoltageType_R)
	{
		LCD_Grayscale(LCD_Grayscale85);
		LCD_GrayscaleCMD(ENABLE);
	}
	else
	{
		LCD_GrayscaleCMD(DISABLE);
	}
	for(i=0;i<15;i++)
	{
		LCD_ClearPage(i);	//ҳ0ʾ
	}
	LCD_SetDramCOM(LCD_PIN_0,LCD_COM_0,ENABLE);
	LCD_SetDramCOM(LCD_PIN_1,LCD_COM_1,ENABLE);
	LCD_SetDramCOM(LCD_PIN_2,LCD_COM_2,ENABLE);
	LCD_SetDramCOM(LCD_PIN_3,LCD_COM_3,ENABLE);
}


/**
  * @brief  תΪɹLCDȡʾĸʽ
  * @note  
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  * @retval Get_Table_Dataתɵ
  */
u8 Get_Dis_Format(u8 Dis_data)
{
	u8 Get_Table_Data;
	Get_Table_Data = Display_Char_Table[Dis_data];
	return Get_Table_Data;
}

/**
  * @brief  ָݷ͵LCDӦPageĴ
  * @note  
  * @param  Dis_BIT: 1~4ʾDEMOLCDʾλ
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  * @param  Page: 0~15LCDʾĴ16ҳ
  * @retval None
  */
void Buff_Dis_Data_To_Page(u8 Dis_BIT,u8 Dis_Data,u8 Page)
{
	u8 addr_offset=0;
	u8 low_offset=0,high_offset=0;
	u16 Bit16_Low_Byte, Bit16_High_Byte;
	u32 And_Data=0;
	
	Bit16_Low_Byte  =  Dis_Data & 0x0F;
	Bit16_High_Byte  =  Dis_Data >> 4;

	if(Dis_BIT==1||Dis_BIT==3)
	{
		low_offset=0;
		high_offset=8;
		And_Data=0XFFFF0000;
	}
	if(Dis_BIT==2||Dis_BIT==4)
	{
		low_offset=16;
		high_offset=24;
		And_Data=0X0000FFFF;
	}
	
	if(Dis_BIT==1||Dis_BIT==2)
	{
		addr_offset=0X04;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)&=And_Data;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)|=(Bit16_High_Byte << high_offset) | (Bit16_Low_Byte<<low_offset);
	}
	if(Dis_BIT==3||Dis_BIT==4)
	{
		addr_offset=0X08;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)&=And_Data;
		*((u32 volatile *) (LCD_DATA_BASE + addr_offset) + 8 * Page)|=(Bit16_High_Byte << high_offset) | (Bit16_Low_Byte << low_offset);
	}
}

/**
  * @brief  ָҺϣʾָ
  * @note  
  * @param  Dis_BIT: 1~4ʾDEMOLCDʾλ
  * @param  Dis_Data: 0~20ʾLCDʾ֣οDisplay_Char_Table
  *        
  * @retval None
  */
void Display_number(u8 Dis_BIT,u8 Dis_Data,u8 Dis_Page)
{
	Dis_Data=Get_Dis_Format(Dis_Data);
	Buff_Dis_Data_To_Page(Dis_BIT,Dis_Data,Dis_Page);
}

void Wake_Key_Init(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;
	GPIO_InitTypeDef GPIO_InitStructure;					//һGPIO_InitTypeDef͵Ľṹ
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;	//ģʽΪ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init(GPIOD, &GPIO_InitStructure);			//ÿ⺯ʼGPIO
	
	//GPIO˿жϴѡ
	EXTI_TriTypeConfig(EXTID,EXTI_Pin_3, EXTI_Trigger_LowLevel);
	EXTI_ITConfig(EXTID,EXTI_IT_3,ENABLE);

	/*ʹGPIONVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = EXTID_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;
	NVIC_Init(&NVIC_InitStruct);
}
void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}
void GoToSleep(void)
{
	u16 temp16;
	GPIO_InitTypeDef GPIO_InitStructure={0};
	//PA13,PA14ΪSWD;PA2-PA5 COM;PA6-PA12ݲ
	temp16 = GPIO_Pin_All & (~(GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5));  
	GPIO_InitStructure.GPIO_Pin = 	temp16;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;			
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_Init(GPIOA, &GPIO_InitStructure);			
	//PB10,11ΪXTLţݲ
	temp16 = GPIO_Pin_All & (~(GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7));
	GPIO_InitStructure.GPIO_Pin = 	temp16;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;			
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_Init(GPIOB, &GPIO_InitStructure);			
	//PC4-C5,C10-C12ΪSEG;PC13:RST 
	temp16 = GPIO_Pin_All;
	GPIO_InitStructure.GPIO_Pin = 	temp16;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;			
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_Init(GPIOC, &GPIO_InitStructure);			
	//PD2 SIG;PD3 KEY
	temp16 = GPIO_Pin_All&(~GPIO_Pin_3);
	GPIO_InitStructure.GPIO_Pin = 	temp16;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;			
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	
	//˯ǰLCD˯߶
	//ݽ˯ʱãΪC->R->C;Rѹö
	if(LCD_DriveTypeSelect==LCD_DriveVoltageType_C)
	{
		LCD_GrayscaleCMD(DISABLE);
		LCD_CMD(DISABLE);
		LCD_DriveTypeConfig(LCD_DriveType_R);//C->R
		LCD_CMD(ENABLE);
		LCD_CMD(DISABLE);
		LCD_DriveTypeConfig(LCD_DriveType_C);//R->C
		LCD_CMD(ENABLE);
	}
	PWR_EnterSTANDBYMode(PWR_STANDBYEntry_WFI);

	Software_Delay();
}

int main (void)
{
	u8 i;
	LCD_GPIO_Config();
	LCD_Mode_Config();
	Wake_Key_Init();

	for(i = 0; i < 16; i++)
	{
		Display_number(1,1+i,0+i);
		Display_number(2,1+i,0+i);
		Display_number(3,1+i,0+i);
		Display_number(4,1+i,0+i);
	}
	LCD_CMD(ENABLE);			  //ʹLCD	
	LCD_UpdataCMD(ENABLE);	//LCDʾ
	Software_Delay();

	while(1)
	{	
		GoToSleep();
		Software_Delay();
		Software_Delay();
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


