/******************************************************************************
  * @Example PT32x033x_CRC
  * @author  ӦÿŶ
  * @version V1.4.0
  * @date    2023/10/27
  * @brief   ӲCRCCRCõֵжԱȣͨڴӡԱȽ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *								
  *							
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *****************************************************************************/
	
#include "PT32x033x.h"

extern u16 crc_ccitt_fast(u16 crc, u8* buffer, u32 length);

u8 NORMAL_DATA_BUF[256]; //ܵݻ
u8 err=0;

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

u16 rev_hw(u16 in) // ߵֽ˳л 
{
	u32 out = __rev((u32)in);

	return (u16)(out>>16);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_0, AFIO_AF_0,ENABLE);	//PA0 TX0
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_1, AFIO_AF_0,ENABLE);	//PA1 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLength = UART_WP_8D;
	UART_InitStruct.UART_StopBits = UART_STOP_1b;
	UART_InitStruct.UART_Parity = UART_Parity_Even;
	UART_InitStruct.UART_Mode=UART_Mode_RxEnable;
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UARTģ
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief ʼCRCģĹ乤ʽ
* @param 
* @retval 
*/
void CRC_Driver(void)
{
	CRC_InitTypeDef CRC_InitStructure;					//һCRC_InitTypeDef͵Ľṹ
	
	CRC_StructInit(&CRC_InitStructure);					//ʹĬֵʼCRC_InitStructure
	
	CRC_InitStructure.CRC_ReInByte=ENABLE;		//ֽзת ֻ16bitģʽЧ
	CRC_InitStructure.CRC_ReInBit = DISABLE;		//λзת
	CRC_InitStructure.CRC_ReOutBit = DISABLE;		//λзת
	CRC_InitStructure.CRC_DinWidth = CRC_CIS_16b;		//16 λݿ
	CRC_InitStructure.CRC_Poly = CRC_CCITT16;		//öʽϵ
	CRC_InitStructure.CRC_Seed = 0;						//CRCʼֵ
	CRC_Init(&CRC_InitStructure);						//ʼCRC
	
	CRC_Cmd(ENABLE);									//CRCʹ
	CRC_ResetDout();									//CRCĴ
}

int main(void)
{
	u32 length,i=0;
	u8 *buf8;
	u16 *buf16;
	u16 sum1, sum2,CRC_Result;	
	CRC_Result = 0;										//CRCʼֵ  
	
	Software_Delay();
	UART_Driver();	
	CRC_Driver();	
	
	buf8 = (u8*)NORMAL_DATA_BUF;   
	buf16 = (u16*)NORMAL_DATA_BUF; 
	
	for (i=0; i<256; i++) 
	{
		*buf8++ = (u8)i;    
	} 
	/* CRC */
	buf8 = (u8*)NORMAL_DATA_BUF;	
	buf16 = (u16*)NORMAL_DATA_BUF;
	
	length = 256;		
	sum1 = crc_ccitt_fast(CRC_Result, buf8, length);	//ȡCRCֵ

	/* ӲCRC */
	length /= 2;
	while (length--)
	{ 
		CRC->DIN=*buf16++;
	}	
	sum2 = (u16)CRC_GetCRC();							//ȡCRCֵ
	

	/* 2μȽ */
	if(sum1 != sum2)
	{
		err++;
		printf("error\r\n");   
	}		
	else if(sum1 == sum2)
	{
		printf("CRCӲCRCͬ\r\nCRC:%d\tӲCRC:%d\r\n",sum1,sum2);
	}  
	
	
	while (1)
	{
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
